#ifndef TOKENIZER_H
#define TOKENIZER_H

#ifdef __cplusplus
extern "C" {
#endif

#include "Error.h"
#include "Types.h"
#include "tokenizer/Token.h"

void tTokenize(const char* path, Error* e);

Token tPeekToken(void);
bool tReadTokenAndLine(Token* t, int16* line);
bool tReadInt32(int32* i);
bool tReadFloat(float* f);
const char* tReadString(void);
int tGetMarker(void);
void tReset(int marker);

#ifdef __cplusplus
}
#endif

#endif